/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:01:47 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.civicinfo.model;

/**
 * Information about the election that was queried.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Civic Information API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Election extends com.google.api.client.json.GenericJson {

  /**
   * Day of the election in YYYY-MM-DD format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String electionDay;

  /**
   * The unique ID of this election.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long id;

  /**
   * A displayable name for the election.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Day of the election in YYYY-MM-DD format.
   * @return value or {@code null} for none
   */
  public java.lang.String getElectionDay() {
    return electionDay;
  }

  /**
   * Day of the election in YYYY-MM-DD format.
   * @param electionDay electionDay or {@code null} for none
   */
  public Election setElectionDay(java.lang.String electionDay) {
    this.electionDay = electionDay;
    return this;
  }

  /**
   * The unique ID of this election.
   * @return value or {@code null} for none
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * The unique ID of this election.
   * @param id id or {@code null} for none
   */
  public Election setId(java.lang.Long id) {
    this.id = id;
    return this;
  }

  /**
   * A displayable name for the election.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * A displayable name for the election.
   * @param name name or {@code null} for none
   */
  public Election setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public Election set(String fieldName, Object value) {
    return (Election) super.set(fieldName, value);
  }

  @Override
  public Election clone() {
    return (Election) super.clone();
  }

}
